#!/usr/bin/python
################################################################################
#	BdsMetaData7.py		BDS API example code for a BDS MetaData Client
#	T.Barnaby,	BEAM Ltd,	2021-07-05
################################################################################
#
#
# Sheila's example to tead a response from a file.
#
import sys
import time
import copy
import getopt
from bdslib import *

def main():
	err = BError();
	responsefilename = "bdsMetaData7-response.pz";
	pzfile = DataFileResponse();
	pzresp = Response();

	bds = AdminAccess();
	hostName = "barnes";
	user1 = "testAdmin";
	pass1 = "beam00";

	bds.connectService ("//" + hostName + "/bdsAdminAccess");
	bds.connect(user1, pass1);
	bds.transactionStart();

	err = pzfile.open(responsefilename, "r");
	pzfile.setFormat("RESPONSE");
	
	channelInfos = ChannelInfos();
	metadataerrors = BListDataError();

	if(1):	
		print("getMetaData");
		(err, channelInfos, metadataerrors) = pzfile.getMetaData(0);

		print("Output response");

		if(channelInfos):
			pzresp = channelInfos.channels[0][0].responses;
			print ("Poles :");
			for i in range(len(pzresp[0].poleZeros.poles)):
				print (pzresp[0].poleZeros.poles[i]);
			print ("Zeros :");
			for i in range(len(pzresp[0].poleZeros.zeros)):
				print (pzresp[0].poleZeros.zeros[i]);

		if(metadataerrors):
			print ("Metadata errors were detected.");

	if(1):
		print("setMetaData");
		dataInfo = DataInfo();
		(err) = pzfile.setInfo(dataInfo, channelInfos, 0);

	pzfile.close();
	sys.exit(0);

if __name__ == "__main__":
	main();
