/*******************************************************************************
 *	BDspDcRemove.h	IIR Filter Class
 *			T.Barnaby,	BEAM Ltd,	2006-02-09
 *******************************************************************************
 */
#ifndef BDspDcRemove_H
#define BDspDcRemove_H	1

#include <stdint.h>
#include <BDspFifo.h>
#include <BDspMain.h>

/// This class implements a Raw DC Removal filter
class BDspDcRemove {
public:
			BDspDcRemove(double coefficient = 0.9995, double initialValue = 0.0);
	
	void		process(int numSamples, float* sigIn, float* sigOut);

private:
	double		ocoefficient;
	BDspSample	opreviousIn;
	BDspSample	opreviousOut;
};

/// This class implements a DC Removal filter
class BDspDcRemoveFifo : public BDspFifoProcess {
public:
			BDspDcRemoveFifo(BDspFifo& input, BDspFifo& output, double coefficient = 0.9995, double initialValue = 0.0);
	
	BError		process(BUInt numSamples);

private:
	double		ocoefficient;
	BDspSample	opreviousIn;
	BDspSample	opreviousOut;
};


#endif
