/*******************************************************************************
 *	BDspFilterFir.h	FIR Filter Class
 *			T.Barnaby,	BEAM Ltd,	2005-11-18
 *******************************************************************************
 */
#ifndef BDspFilterFir_H
#define BDspFilterFir_H	1

#include <BDspMain.h>
#include <BDspFifo.h>
#include <BDspFilterDesign.h>
#include <gr_fir_fff_x86.h>
#include <gr_fir_ccf_x86.h>

/// This class implements a FIR filter
class BDspFilterFir {
public:
				BDspFilterFir(BDspFilterDesign design, int decimate);
	
	void			process(int numSamples, BDspSample* sigIn, BDspSample* sigOut);
	void			process(int numSamples, BDspCSample* sigIn, BDspCSample* sigOut);
	int			numTaps();

private:
	BDspFilterDesign	odesign;
	int			odecimate;
	gr_fir_fff_sse		ofilter;
	gr_fir_ccf_sse		ofilterComplex;
};

/// This class implements a FIR filter using FIFO's for input and output
class BDspFilterFirFifo : public BDspFifoProcess {
public:
				BDspFilterFirFifo(BDspFifo& input, BDspFifo& output, BDspFilterDesign design, BUInt decimate);
	
	BError			process(BUInt numSamples);
	int			numTaps();

private:
	BDspFilterDesign	odesign;
	BUInt			odecimate;
	gr_fir_fff_sse		ofilter;
};

#endif
