/*******************************************************************************
 *	BDspFilterHilbert.h	Hilbert Filter Class
 *			T.Barnaby,	BEAM Ltd,	2006-03-10
 *******************************************************************************
 */
#ifndef BDspFilterHilbert_H
#define BDspFilterHilbert_H	1

#include <BDspMain.h>
#include <BDspFifo.h>
#include <BDspFilterDesign.h>
#include <gr_fir_fff_x86.h>

/// This class implements a FIR filter
class BDspFilterHilbert {
public:
				BDspFilterHilbert(int numTaps);
	
	void			process(int numSamples, BDspSample* sigIn, BDspCSample* sigOut);
	void			process(int numSamples, BDspSample* sigIn, BDspSample* sigOut);
	int			numTaps();

private:
	BDspFilterDesign	odesign;
	gr_fir_fff_sse		ofilter;
};

/// This class implements a FIR filter using FIFO's for input and output
class BDspFilterHilbertFifo : public BDspFifoProcess {
public:
				BDspFilterHilbertFifo(BDspFifo& input, BDspFifo& output, int numTaps);
	
	BError			process(BUInt numSamples);
	int			numTaps();

private:
	BDspFilterHilbert	ofilter;
};

#endif
