/*******************************************************************************
 *	BDspFilterIir.h	IIR Filter Class
 *			T.Barnaby,	BEAM Ltd,	2006-02-09
 *******************************************************************************
 */
#ifndef BDspFilterIir_H
#define BDspFilterIir_H	1

#include <BDspMain.h>
#include <BDspFifo.h>
#include <BDspFilterDesign.h>
#include <gri_iir.h>

typedef std::vector<float>	BDspArrayFloat;

/// This class implements a Raw IIR filter
class BDspFilterIir {
public:
			BDspFilterIir(BDspFilterDesign design, int decimate);
			~BDspFilterIir();
	
	void		process(int numSamples, float* sigIn, float* sigOut);
	int		numTaps();
private:
	BDspFilterDesign		odesign;
	int				odecimate;
	gri_iir<float,float,double>	ofilter;
	float*				obuffer;
	int				obufferLen;
};

/// This class implements a IIR filter using input and output FIFO's
class BDspFilterIirFifo : public BDspFifoProcess {
public:
			BDspFilterIirFifo(BDspFifo& input, BDspFifo& output, BDspFilterDesign design, BUInt decimate);
	
	BError		process(BUInt numSamples);
	int		numTaps();

private:
	BDspFilterDesign		odesign;
	BUInt				odecimate;
	gri_iir<float,float,double>	ofilter;
};



#endif
