/*******************************************************************************
 *	BDspFmDemodulateSimple.h	FM Demodulator Class
 *				T.Barnaby,	BEAM Ltd,	2005-11-25
 *******************************************************************************
 */
#ifndef BDspFmDemodulateSimple_H
#define BDspFmDemodulateSimple_H	1

#include <BDspMain.h>
#include <BDspFifo.h>


/// This class implements an FM Demodulator
class BDspFmDemodulateSimpleFifo : public BDspFifoProcess {
public:
			BDspFmDemodulateSimpleFifo(BDspFifo& input, BDspFifo& output, double sampleRate, double centerFreq, double squelch = 0.25, double modIndex = 1.0);

	void		setCenterFreq(double freq);	
	BError		process(BUInt numSamples);
private:
	BDspSample	clip(BDspSample s);
	double		osampleRate;
	double		ocenterFreq;
	double		osquelch;
	double		oclipLevel;
	double		omodIndex;
	BDspSample	opreviousBDspSample;
};

#endif
