/*******************************************************************************
 *	BdsDataFileIdc.h	IDC Response Data File Access
 *	T.Barnaby,	BEAM Ltd,	2021-05-27
 *******************************************************************************
 */
#ifndef BdsDataFileIdc_H
#define	BdsDataFileIdc_H

#include <BdsDataFile.h>
#include <BdsD.h>

namespace Bds {

/// This class defines the interface for IDC response data file access
class DataFileIdc : public DataFile {
public:
				DataFileIdc();
	
	int			getFeatures();								///< Get bitmask of supported features
	
				// Read routines
	BError			getMetaData(ChannelInfos& channelInfos, BUInt32 options, BList<DataError>& errors);		///< Return all known MetaData in the file

				// Write routines
	BError			setInfo(const DataInfo& dataInfo, const ChannelInfos& channelInfos, WriteOptionsList options);

	static DataFormats	getFormats();
private:
	BError			readIdcResponse();
	BError			writeIdcResponse(ChannelInfo& ci, Response& r);
	
	DataInfo		odataInfo;
	ChannelInfo		ochannelInfo;
	ChannelInfos		ochannelInfos;
};

}
#endif
