/*******************************************************************************
 *	BdsDataFileLog.h	Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-06-24
 *******************************************************************************
 */
#ifndef BdsDataFileLog_H
#define	BdsDataFileLog_H

#include <BdsDataFile.h>
#include <BdsD.h>

namespace Bds {

/// Data file convertor for LOG format files.
class DataFileLog : public DataFile {
public:
				DataFileLog();

	BError			open(BString fileName, BString mode);

	DataOrder		getDataOrder();
	int			getFeatures();
	
	BError			getInfo(DataInfo& dataInfo, DataFileOptions options, BList<DataError>& errors);
	BError			readData(BUInt32 channel, BUInt segment, BUInt32 blockNumber, DataBlock& data);

	BError			setFormat(BString format);
	BError			setInfo(const DataInfo& dataInfo, const ChannelInfos& channelInfos, WriteOptionsList options = WriteOptionSensorData);
	BError			start(BUInt channel, BUInt segment);
	BError			writeData(const DataBlock& data);
	BError			end();

	static DataFormats	getFormats();

private:
	BError			readBlock(BUInt32 channel, BUInt64 pos, DataBlock& data, BUInt64& posNext);

	DataInfo		odataInfo;
	ChannelInfos		ochannelInfos;
	BString			oformat;
	BArray<DataBlockPos>	oblockPositions;
};

}
#endif
