/*******************************************************************************
 *	BdsDataFileSac.h	Data File Access
 *			T.Barnaby,	BEAM Ltd,	2010-09-15
 *******************************************************************************
 */
#ifndef BdsDataFileSac_H
#define	BdsDataFileSac_H

#include <BdsDataFile.h>
#include <BdsD.h>

namespace Bds {

/// Data file convertor for SAC format files.
class DataFileSac : public DataFile {
public:
				DataFileSac();

	int			getFeatures();

				// Read routines
	BError			getMetaData(ChannelInfos& channelInfos, BUInt32 options, BList<DataError>& errors);		///< Return all known MetaData in the file

				// Write routines
	BError			setInfo(const DataInfo& dataInfo, const ChannelInfos& channelInfos, WriteOptionsList options = WriteOptionNone);

	static DataFormats	getFormats();
private:
	BError			readSacPoleZero();
	BError			writeResponses();

	DataInfo		odataInfo;
	ChannelInfo		ochannelInfo;
	ChannelInfos		ochannelInfos;
};

}
#endif
